package com.fp.persistence.pgeneral.score;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESCORE*/
@Entity(name="TgeneScore")
@Table(name="TGENESCORE")
public class TgeneScore extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneScore
*/
@Id
@Column(name="SCORECODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="REALSCORE", nullable=true)

/**
* Codigo de calificacion real a presentar a los organismos de control.
*/
private String realscore;

@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion asociada al codigo de calificacion.
*/
private String description;

/**Contructor por defecto*/
public TgeneScore(){
}
/**Contructor de TgeneScore
@param pPk Clave Primaria del entity
*/
public TgeneScore(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneScore
*/
public static TgeneScore find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneScore obj = pEntityManager.find(TgeneScore.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneScore
@return El objeto que referencia a la Clave primaria de TgeneScore
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneScore
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneScore
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de realscore
@return valor de realscore*/
public String getRealscore(){
  return realscore;
}
/**Fija el valor de realscore
@param pRealscore nuevo Valor de realscore*/
public void setRealscore(String pRealscore){
  realscore=pRealscore;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneScore))return false;
    TgeneScore that = (TgeneScore) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneScore
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneScore
*/
public Object createInstance(){
 TgeneScore instance=new TgeneScore();	
 return instance;
}
/**Clona la entidad TgeneScore
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneScore p=(TgeneScore)this.clone();
  return p;
}
}
